//+------------------------------------------------------------------+
//|                                    Spearman Rank Correlation.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  8
#property indicator_color1   DimGray
#property indicator_color2   LimeGreen
#property indicator_color3   LimeGreen
#property indicator_color4   Orange
#property indicator_color5   Orange
#property indicator_color6   Red
#property indicator_color7   LimeGreen
#property indicator_color8   DimGray
#property indicator_style8   STYLE_DOT
#property indicator_width2   3
#property indicator_width3   3
#property indicator_width4   3
#property indicator_width5   3
#property indicator_minimum -1
#property indicator_maximum  1

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import "spearman.dll"
   double rankSpearman(double& sourceArray[],bool isSeries, int rank, int bars, int i);
#import

//
//
//
//
//

extern string TimeFrame              = "Current time frame";
extern int    Rank                   = 14;
extern int    Price                  = PRICE_CLOSE;
extern int    DzLookBackBars         = 70;
extern double DzStartBuyProbability  = 0.05;
extern double DzStartSellProbability = 0.05;
extern bool   Interpolate            = true;
extern bool   alertsOn               = true;
extern bool   alertsOnCurrent        = true;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsEmail            = false;

//
//
//
//
//

double rank[];
double rankUa[];
double rankUb[];
double rankDa[];
double rankDb[];
double bli[];
double sli[];
double zli[];
double prices[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0, rank);
   SetIndexBuffer(1, rankUa);
   SetIndexBuffer(2, rankUb);
   SetIndexBuffer(3, rankDa);
   SetIndexBuffer(4, rankDb);
   SetIndexBuffer(5, bli);
   SetIndexBuffer(6, sli);
   SetIndexBuffer(7, zli);
   
      //
      //
      //
      //
      //
      
         Rank = MathMax(Rank,10);
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);

         
      //
      //
      //
      //
      //
          
   IndicatorShortName(timeFrameToString(timeFrame)+" Spearman (" + Rank + ")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double coef         = MathPow(Rank,3) - Rank;
   int    counted_bars = IndicatorCounted();
   int    i,k,r,n,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rank[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (ArraySize(prices)!= Bars) { ArrayResize(prices,Bars); ArrayResize(trend,Bars); }
   if (calculateValue || timeFrame == Period())
   {
      if (!calculateValue && trend[Bars-limit-1]== 1) CleanPoint(limit,rankUa,rankUb);
      if (!calculateValue && trend[Bars-limit-1]==-1) CleanPoint(limit,rankDa,rankDb);
      for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         prices[r] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         rankUa[i] = EMPTY_VALUE;
         rankUb[i] = EMPTY_VALUE;
         rankDa[i] = EMPTY_VALUE;
         rankDb[i] = EMPTY_VALUE;
         rank[i]   = rankSpearman(prices,false,Rank,Bars,i);
         bli[i]    = dzBuyP (rank, DzStartBuyProbability,  DzLookBackBars, Bars, i, 0.0001);
         sli[i]    = dzSellP(rank, DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
         zli[i]    = dzSellP(rank, 0.5,                    DzLookBackBars, Bars, i, 0.0001);
         trend[r]  = trend[r-1];
         trend[r]  = 0;
         
            //
            //
            //
            //
            //
            
            if (rank[i]>sli[i])                    trend[r]= 1;
            if (rank[i]<bli[i])                    trend[r]=-1;
            if (rank[i]>bli[i]  && rank[i]<sli[i]) trend[r]= 0;
            if (!calculateValue && trend[r] ==  1) PlotPoint(i,rankUa,rankUb,rank);
            if (!calculateValue && trend[r] == -1) PlotPoint(i,rankDa,rankDb,rank);
            if (calculateValue) rankUa[i] = trend[r];
      }      
      manageAlerts();
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit, r=Bars-i-1;i>=0;i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         rank[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rank,Price,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,0,y);
         trend[r]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rank,Price,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,1,y);
         bli[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rank,Price,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,5,y);
         sli[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rank,Price,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,6,y);
         zli[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Rank,Price,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,7,y);
         rankUa[i] = EMPTY_VALUE;
         rankUb[i] = EMPTY_VALUE;
         rankDa[i] = EMPTY_VALUE;
         rankDb[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               rank[i+k] = rank[i] + (rank[i+n]-rank[i])*k/n;
               bli[i+k]  = bli[i]  + (bli[i+n] -bli[i] )*k/n;
               sli[i+k]  = sli[i]  + (sli[i+n] -sli[i] )*k/n;
               zli[i+k]  = zli[i]  + (zli[i+n] -zli[i] )*k/n;
            }
   }
   for (i=limit,r=Bars-i-1;i>=0;i--,r++)
   {
      if (trend[r]== 1) PlotPoint(i,rankUa,rankUb,rank);
      if (trend[r]==-1) PlotPoint(i,rankDa,rankDb,rank);
   }
   
   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[Bars-whichBar-1] != trend[Bars-whichBar-2])
      {
         if (trend[Bars-whichBar-1] ==  1) doAlert(whichBar,DoubleToStr(sli[whichBar]  ,4)+" broken up");
         if (trend[Bars-whichBar-1] == -1) doAlert(whichBar,DoubleToStr(bli[whichBar]  ,4)+" broken down");
         if (trend[Bars-whichBar-2] == -1) doAlert(whichBar,DoubleToStr(bli[whichBar+1],4)+" broken up");
         if (trend[Bars-whichBar-2] ==  1) doAlert(whichBar,DoubleToStr(sli[whichBar+1],4)+" broken down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," spearman level ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Spearman rank"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
string stringUpperCase(string str) { StringToUpper(str); return(str); }